package com.zd.laboratory.service;

import java.util.List;
import java.util.Map;

import com.zd.laboratory.domain.LabApproval;
import com.zd.laboratory.domain.LabSecurityGroup;
import com.zd.laboratory.domain.dto.LabApprovalAndDetailDTO;
import com.zd.laboratory.domain.vo.LabApprovalVO;
import com.zd.laboratory.domain.vo.LabSecurityGroupVO;

/**
 * 安全准入审批记录Service接口
 *
 * @author zd
 * @date 2021-08-31
 */
public interface ILabApprovalService {
    /**
     * 查询安全准入审批记录
     *
     * @param id 安全准入审批记录主键
     * @return 安全准入审批记录
     */
    public LabApprovalAndDetailDTO selectLabApprovalById(Long id);

    /**
     * 查询安全准入审批记录列表
     *
     * @param labApproval 安全准入审批记录
     * @return 安全准入审批记录集合
     */
    public List<LabApprovalVO> selectLabApprovalList(LabApproval labApproval);

    /**
     * 新增安全准入审批记录
     *
     * @param labApproval 安全准入审批记录
     * @return 结果
     */
    public int insertLabApproval(LabApprovalAndDetailDTO labApproval);

    /**
     * 修改安全准入审批记录
     *
     * @param labApproval 安全准入审批记录
     * @return 结果
     */
    public int updateLabApproval(LabApprovalAndDetailDTO labApproval);

    /**
     * 安全准入审批操作
     *
     * @param labApproval 安全准入审批操作
     * @return 结果
     */
    public int appOperation(LabApproval labApproval);


    /**
     * 安全准入拒绝操作
     *
     * @param labApproval 安全准入拒绝操作
     * @return 结果
     */
    public int failedOperation(LabApproval labApproval);


    /**
     * 批量删除安全准入审批记录
     *
     * @param ids 需要删除的安全准入审批记录主键集合
     * @return 结果
     */
    public int deleteLabApprovalByIds(Long[] ids);

    /**
     * 删除安全准入审批记录信息
     *
     * @param id 安全准入审批记录主键
     * @return 结果
     */
    public int deleteLabApprovalById(Long id);

    LabSecurityGroupVO querySecurityBySubjectId(Long subjectId);


    /**
     * 统计安全准入审批不同列表信息
     *
     * @param labApproval
     * @return 统计安全准入审批不同列表信息
     */
    public LabApprovalVO getApprovalCount(LabApproval labApproval);


    /**
     * 查询安全准入审批记录列表
     *
     * @param labApproval 安全准入审批记录
     * @return 安全准入审批记录集合
     */
    public List<LabApprovalVO> getApprovalList(LabApproval labApproval);

    List<LabApprovalVO> selectApprovalListByUser(LabApproval labApproval);

    List<Map<String, Object>> statistics(LabApproval labApproval);
}
